<?php
if (gets('authenticated')<1) {echo "<h2 style='color:red'>Access denied: Not logged in.</h2>"; exit; }

require_once 'resizer.php';

function hf_imglist($location, $dmaxwidth=240, $dmaxheight=80, $recursive=0, $hpfilter="") {
// echo $location ."|". $hpfilter;
 $itemcount=0;
 $location=path($location);
 $direxclusions = array( 'cgi-bin', '.', '..', 'codebase', 'archive' ,'menu','frame','material','undo','tmp','log','.thumb');

 $imglist='gif,jpg,jpeg,png';
 $dcontents=hf_scantree($location,0,$recursive,$imglist,$direxclusions);
 $imgtypes=explode(',',$imglist);

 if (count($dcontents)<0) {
    echo "<h2>No associated media files found.</h2>";
    return;
 }    
 foreach($dcontents as $ordinal=>$thisitem) {

  $mediatype='';
  if (!isset($thisitem['type'])) continue ;
  if(in_array($thisitem['type'],$imgtypes)) $mediatype="image";
  if ($mediatype==='') continue;

  $itemcount++; 
  $linebreak=chr(13);
  
  $picinfo=getpicinfo($thisitem['fspath'],$dmaxwidth, $dmaxheight);
  $asizing=$picinfo['x'].'x'.$picinfo['y'];
  $hsizing=' width='.$picinfo['dx'].' height='.$picinfo['dy'].' ';
  $thisitem['description']="File: ". $thisitem['name']. 
  "$linebreak Location: " .$thisitem['webpath']."$linebreak Uploaded: ".
  date('Y/m/d  h:m', $thisitem['time']).
  "$linebreak".hf_formatBytes($thisitem['size'])." " .$asizing. " px";
 
  $webpath=$thisitem['webpath'];
  $description=$thisitem['description'];
  // poss problem area, temp fix, hardcoded location :  *****
  $selectedimg='img/'.$thisitem['name'];
  if (strlen($hpfilter)>0) {
    if (stripos(basename($thisitem['name']),$hpfilter)!==0) continue;
  }
  $out="<a href='javascript:setimg(\"".$selectedimg."\")' class='hf_quickimage'>";
  $out .= "<img src='$webpath' class='hf_quickimage' name='$webpath' id='$selectedimg' title='$description' alt='$webpath' $hsizing> </a>\n";
//  $out.="</td></tr><tr><td style='font-size:small'>$selectedimg</td></tr></table>";
  echo $out;
 }
 if ($itemcount==0) echo "<h2>No associated media files found.</h2>";
?>
<script>
function setimg(selectedimg){
  document.getElementById(selectedimg).style.border='1px red solid';
  if (typeof qi_prevselectedimg != 'undefined'){ document.getElementById(qi_prevselectedimg).style.border='none';}
  qi_prevselectedimg=selectedimg;
  parent.document.uploader.webpathname.value=selectedimg; 
  // document.ajaxreply.img_url.value=selectedimg;
  return void(0);
}
</script>
<?php
 return;
}

function hf_scantree($startdir, $include_hidden=false, $recursive=true, $extensions="",$exclusions="",$dirlimit=1000, $thumbdir='.thumb'){
// Returns an array of file data. 

// Trap various directory-traversal attempts..

 if (substr($startdir,0,1)=='/') return ""; 
 if (stristr($startdir,'..')!==false) return ""; 
 if (stristr($startdir,'//')!==false) return ""; 
 if (stristr($startdir,'\\')!==false) return ""; 
 if (stristr($startdir,':')!==false) return ""; 

$dirct=0;
$depth=0;
$files="";
$thumbdir=path($thumbdir);
if (is_array($exclusions)){
 $direxclusions=$exclusions;
}else{ 
 if ($exclusions<>""){
   $direxclusions=explode(",",strtolower($exclusions)); 
 }else{
   $direxclusions[]="*";
 } 
}

if ($extensions<>""){
  $filetypes=explode(",",strtolower($extensions)); 
}else{
  $filetypes="*";
}    

// $startdir is always relative to hyperframe site root. 
if (substr($startdir,0,1)=="/") $startdir=substr($startdir,1);
$scanq[]=$startdir;
$ordinal=0;
while (true) :
 // $thispath is relative to website root 
 $thispath=path(array_shift($scanq));
 if ($thispath==null) break;
 $depth=str_word_count($thispath, 0, '3');
 $dcontents = scandir(fsroot . $thispath);
 natsort($dcontents);
 $dirct++;
 foreach ($dcontents as $thisitem) {
   if(!$include_hidden && (substr($thisitem,0,1)==".") ) continue;
   $dir=is_dir(fsroot.$thispath.$thisitem);
   if ($dir) {
     if(!in_array(strtolower($thisitem),$direxclusions)) $scanq[]=path($thispath . $thisitem);
   } else {
//     if(substr($thisitem,-6,2)=="_t") continue; // Skip thumbs generated by IrfanView
     $thisext = strtolower(substr(strrchr($thisitem, '.'), 1));
     if(($filetypes=="*") || (in_array($thisext,$filetypes))) {
       $ordinal++; 
       $files[$ordinal]['name']=$thisitem;     
       $files[$ordinal]['relpath']=$thispath;     
       $files[$ordinal]['webpath']=siteroot.$thispath.$thisitem;     
       $files[$ordinal]['fspath']=fsroot.$thispath.$thisitem;     
       $files[$ordinal]['type']=$thisext;
       $files[$ordinal]['size']=filesize(fsroot.$thispath.$thisitem);
       $files[$ordinal]['time']=filemtime(fsroot.$thispath.$thisitem);
       $files[$ordinal]['webthumbpath']=siteroot.$thispath.$thumbdir.$thisitem;
       $files[$ordinal]['fsthumbpath']=fsroot.$thispath.$thumbdir.$thisitem;
     }
   }
 }
 if ($recursive!=true || $dirct>$dirlimit) {
    break;
 }

endwhile;
// always return an array; avoids complications with empty dirs. 
if (!is_array($files)) $files[]="";
return $files;
}

function hf_formatBytes($bytes, $precision = 2) { 
    $units = array('B', 'KB', 'MB', 'GB', 'TB'); 

    $bytes = max($bytes, 0); 
    $pow = floor(($bytes ? log($bytes) : 0) / log(1024)); 
    $pow = min($pow, count($units) - 1); 

    // Uncomment one of the following alternatives
    $bytes /= pow(1024, $pow);
    // $bytes /= (1 << (10 * $pow)); 

    return round($bytes, $precision) . ' ' . $units[$pow]; 
} 


?>
