<?php include_once '../codebase/hyperframe.php' ?>
<!doctype html>
<html>
<head><title></title>
   <META NAME="creation_time" CONTENT="99">
   <META NAME="description" CONTENT="The blog index page contains a list of available articles">
   <META NAME="keywords" CONTENT="">
   <META NAME="hf_frame" CONTENT="blog">
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; utf-8">
</head>
<body>
<h1>Setting up a Hyperframe blog</h1>

<h3>&nbsp;</h3>

<p>In order to create a Hyperframe blog, the main requirement is for pages to use a blogging frame. This frame will call the blog plugin code, and will insert the blog-specific text elements into all such pages.</p>

<h3>Entire website as a blog</h3>

<p>If the entire website will be in blog format, then it is a relatively simple matter to declare a blog-format frame as the default in siteini.php. All pages will then behave as blog articles, regardless of whether they were created online or uploaded.</p>

<h3>Blog as a subsection of main site</h3>

<p>If you wish to make a subsection of your site into a blog, but to retain conventional website behaviour for your main pages, then the way to do this is to set the hf_frame meta tag in the head section of blog pages to reference your blog frame.&nbsp; Leave the site&#39;s default frame as a conventional type.</p>

<p>To save the need to modify the page head section by hand, there is a BlogArticle template available under File..New, which if selected will include this setting in your new page.</p>

<p>It will generally be more convenient to make your subsection blog a subdirectory of the site&#39;s filesystem structure. This way it will have its own index page, and the catalog of articles (TOC) will appear here instead of on the main site&#39;s homepage.&nbsp;</p>

</body>
</html>