<?php include_once 'codebase/hyperframe.php' ?><p><?php multicolumn('div.newspaper_style','3','20px') ?></p>

<h1>Multi-column text</h1>

<h6>requires a reasonably modern browser</h6>

<div class="newspaper_style">
<p>Not strictly a plugin as it&#39;s implemented as system code, but this add-on allows you to display your pages in the format often used by newspapers, that is, as multiple narrow columns of text within the same container. Text automatically reflows according to window size, so there is no need to&nbsp; adjust the column lengths after a page edit.</p>

<p>To use the add-on, you must include in the page source a call to the multicolumn system function as:</p>

<p class="brbr"><strong><small>&lt;?php multicolumn(&#39;div.class&#39;,&#39;columns&#39;,&#39;spacing&#39;) ?&gt;</small></strong></p>

<p>There must also be a div in your page, bearing the stated class (or ID as div#id) and containing the multicolumn text.</p>

<p>For easier text entry, the page will display as a single column in the online editor. Press <em>preview</em> to see the multicolumn version.</p>

<p>The columns and spacing items can be left out, in which case&nbsp; they default to 2 and 10px respectively. Note that the spacing is in css format so must include &#39;px&#39; or &#39;em&#39; etc - a number alone is not accepted.</p>

<p>Pay particular attention to the width of any inline images in the multicolumn region. if these exceed the column with, they will force a reduction in the number of columns. A future plugin version may include code to automatically scale such images to fit the column.</p>

<p>This add-on calls for a recent browser, and older copies of Internet Explorer are the most likely to be unable to display the text correctly. However, older browsers should revert to displaying the text as a single wide column, so the page will still be readable.</p>

<hr />
<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>

<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>

<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?</p>
</div>
