<?php include_once 'codebase/hyperframe.php' ?><h1>Hyperframe !CMS</h1>

<h3>our inhouse-developed website content delivery system.</h3>

<p>Hyperframe performs a similar core function to &#39;Content management systems&#39; such as Joomla!, Drupal or Wordpress, - although it differs in many fundamental aspects from those packages. Probably the most significant difference is its being <em>file based</em> instead of database dependent.</p>

<p><b>As a brief outline of its design principles:</b></p>

<ul>
  <li>Host requirements are recent versions of Apache and php</li>
  <li>Pages are stored as conventional HTML files, as opposed to in an SQL database&nbsp;</li>
  <li>Pages are loaded by native URL, instead of an untidy parameter-string&nbsp;or confusing URL rewrite</li>
  <li>A reliable and substantially quirk-free online editor, plus the ability to upload pages the traditional way</li>
  <li>Configuration is by way of text files rather than browser dialogs</li>
  <li>Common styles and elements are stored in a <em>frame</em>, which is highly customisable</li>
  <li>Menus are cascading, independent of page location, and do not require page refresh to show sublevels</li>
  <li>Page loading should be near-instant, and should not involve &#39;shuggling&#39; of content as it loads</li>
  <li>Hyperframe websites should be location-agnostic, and easily relocatable to a new domain</li>
  <li>A site can use HTML5 or HTML4&nbsp; as desired (and the editor semantics adjust accordingly)</li>
  <li>Disasters should be rare, but always be recoverable by simply replacing the affected files</li>
  <li>System programming should be understandable by a coder of average ability</li>
  <li>But, we won&#39;t waste hours of coding time just to help lamers avoid exercising their brains a little</li>
  <li>Your site should not &#39;look like a Hyperframe site&#39; or even be identifiable as one unless you wish it</li>
  <li>Near-complete flexibility to modify the system itself, if existing controls don&#39;t meet your needs</li>
  <li>Simplest method that does the job satisfactorily, is best</li>
</ul>

<p style="margin-left: 40px;">&nbsp;</p>
